import 'dart:async';
import 'package:esiur/esiur.dart';
import 'Test.MyService.g.dart' as test;
import 'Test.MyGenericRecordOfTest_MyResource.g.dart' as test;
import 'Test.MyResource.g.dart' as test;
import 'Test.MyRecord.g.dart' as test;
import 'Test.SizeEnum.g.dart' as test;
import 'Test.MyChildResource.g.dart' as test;
import 'Test.MyChildRecord.g.dart' as test;

class MyService extends DistributedResource {
  MyService() {
    on('StringEvent', (x) => _StringEventController.add(x));
    on('ArrayEvent', (x) => _ArrayEventController.add(x));
  }
  AsyncReply<test.MyGenericRecordOfTest_MyResource> GetGenericRecord() {
    var args = <UInt8, dynamic>{};
    var rt = AsyncReply<test.MyGenericRecordOfTest_MyResource>();
    internal_invoke(0, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<dynamic> Void() {
    var args = <UInt8, dynamic>{};
    var rt = AsyncReply<dynamic>();
    internal_invoke(1, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<dynamic> InvokeEvents(String msg) {
    var args = <UInt8, dynamic>{UInt8(0): msg};
    var rt = AsyncReply<dynamic>();
    internal_invoke(2, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<double> Optional(dynamic a1, int a2, [String? a3, String? a4]) {
    var args = <UInt8, dynamic>{UInt8(0): a1, UInt8(1): a2};
    if (a3 != null) args[UInt8(2)] = a3;
    if (a4 != null) args[UInt8(3)] = a4;
    var rt = AsyncReply<double>();
    internal_invoke(3, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<dynamic> Connection(dynamic a1, int a2) {
    var args = <UInt8, dynamic>{UInt8(0): a1, UInt8(1): a2};
    var rt = AsyncReply<dynamic>();
    internal_invoke(4, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<dynamic> ConnectionOptional(dynamic a1, int a2, [String? a3]) {
    var args = <UInt8, dynamic>{UInt8(0): a1, UInt8(1): a2};
    if (a3 != null) args[UInt8(2)] = a3;
    var rt = AsyncReply<dynamic>();
    internal_invoke(5, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<Tuple> GetTuple2(int a1, String a2) {
    var args = <UInt8, dynamic>{UInt8(0): a1, UInt8(1): a2};
    var rt = AsyncReply<Tuple>();
    internal_invoke(6, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<Tuple> GetTuple3(int a1, String a2, double a3) {
    var args = <UInt8, dynamic>{UInt8(0): a1, UInt8(1): a2, UInt8(2): a3};
    var rt = AsyncReply<Tuple>();
    internal_invoke(7, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<Tuple> GetTuple4(int a1, String a2, double a3, bool a4) {
    var args = <UInt8, dynamic>{
      UInt8(0): a1,
      UInt8(1): a2,
      UInt8(2): a3,
      UInt8(3): a4
    };
    var rt = AsyncReply<Tuple>();
    internal_invoke(8, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  AsyncReply<test.MyRecord> SendRecord(test.MyRecord record) {
    var args = <UInt8, dynamic>{UInt8(0): record};
    var rt = AsyncReply<test.MyRecord>();
    internal_invoke(9, args)
      ..then((x) => rt.trigger(x))
      ..error((x) => rt.triggerError(x))
      ..chunk((x) => rt.triggerChunk(x));
    return rt;
  }

  int get PropertyContext {
    return get(0);
  }

  set PropertyContext(int value) {
    set(0, value);
  }

  test.SizeEnum get Enum {
    return get(1);
  }

  set Enum(test.SizeEnum value) {
    set(1, value);
  }

  test.MyRecord get Record {
    return get(2);
  }

  set Record(test.MyRecord value) {
    set(2, value);
  }

  List<int> get IntList {
    return get(3);
  }

  set IntList(List<int> value) {
    set(3, value);
  }

  List<IRecord> get RecordsArray {
    return get(4);
  }

  set RecordsArray(List<IRecord> value) {
    set(4, value);
  }

  List<test.MyRecord> get RecordsList {
    return get(5);
  }

  set RecordsList(List<test.MyRecord> value) {
    set(5, value);
  }

  test.MyResource get Resource {
    return get(6);
  }

  set Resource(test.MyResource value) {
    set(6, value);
  }

  test.MyChildResource get ChildResource {
    return get(7);
  }

  set ChildResource(test.MyChildResource value) {
    set(7, value);
  }

  test.MyChildRecord get ChildRecord {
    return get(8);
  }

  set ChildRecord(test.MyChildRecord value) {
    set(8, value);
  }

  List<IResource> get Resources {
    return get(9);
  }

  set Resources(List<IResource> value) {
    set(9, value);
  }

  MyService get Me {
    return get(10);
  }

  set Me(MyService value) {
    set(10, value);
  }

  bool get Boolean {
    return get(11);
  }

  set Boolean(bool value) {
    set(11, value);
  }

  List<bool> get BooleanArray {
    return get(12);
  }

  set BooleanArray(List<bool> value) {
    set(12, value);
  }

  int get UInt8Test {
    return get(13);
  }

  set UInt8Test(int value) {
    set(13, value);
  }

  int? get UInt8Null {
    return get(14);
  }

  set UInt8Null(int? value) {
    set(14, value);
  }

  List<int> get UInt8Array {
    return get(15);
  }

  set UInt8Array(List<int> value) {
    set(15, value);
  }

  List<int?> get UInt8ArrayNull {
    return get(16);
  }

  set UInt8ArrayNull(List<int?> value) {
    set(16, value);
  }

  int get Int8 {
    return get(17);
  }

  set Int8(int value) {
    set(17, value);
  }

  List<int> get Int8Array {
    return get(18);
  }

  set Int8Array(List<int> value) {
    set(18, value);
  }

  String get Char16 {
    return get(19);
  }

  set Char16(String value) {
    set(19, value);
  }

  List<String> get Char16Array {
    return get(20);
  }

  set Char16Array(List<String> value) {
    set(20, value);
  }

  int get Int16 {
    return get(21);
  }

  set Int16(int value) {
    set(21, value);
  }

  List<int> get Int16Array {
    return get(22);
  }

  set Int16Array(List<int> value) {
    set(22, value);
  }

  int get UInt16 {
    return get(23);
  }

  set UInt16(int value) {
    set(23, value);
  }

  List<int> get UInt16Array {
    return get(24);
  }

  set UInt16Array(List<int> value) {
    set(24, value);
  }

  int get Int32Prop {
    return get(25);
  }

  set Int32Prop(int value) {
    set(25, value);
  }

  List<int> get Int32Array {
    return get(26);
  }

  set Int32Array(List<int> value) {
    set(26, value);
  }

  int get UInt32 {
    return get(27);
  }

  set UInt32(int value) {
    set(27, value);
  }

  List<int> get UInt32Array {
    return get(28);
  }

  set UInt32Array(List<int> value) {
    set(28, value);
  }

  int get Int64 {
    return get(29);
  }

  set Int64(int value) {
    set(29, value);
  }

  List<int> get Int64Array {
    return get(30);
  }

  set Int64Array(List<int> value) {
    set(30, value);
  }

  int get UInt64 {
    return get(31);
  }

  set UInt64(int value) {
    set(31, value);
  }

  List<int> get UInt64Array {
    return get(32);
  }

  set UInt64Array(List<int> value) {
    set(32, value);
  }

  double get Float32 {
    return get(33);
  }

  set Float32(double value) {
    set(33, value);
  }

  List<double> get Float32Array {
    return get(34);
  }

  set Float32Array(List<double> value) {
    set(34, value);
  }

  double get Float64 {
    return get(35);
  }

  set Float64(double value) {
    set(35, value);
  }

  List<double> get Float64Array {
    return get(36);
  }

  set Float64Array(List<double> value) {
    set(36, value);
  }

  double get Float128 {
    return get(37);
  }

  set Float128(double value) {
    set(37, value);
  }

  List<double> get Float128Array {
    return get(38);
  }

  set Float128Array(List<double> value) {
    set(38, value);
  }

  String get Text {
    return get(39);
  }

  set Text(String value) {
    set(39, value);
  }

  List<String> get StringArray {
    return get(40);
  }

  set StringArray(List<String> value) {
    set(40, value);
  }

  DateTime get Time {
    return get(41);
  }

  set Time(DateTime value) {
    set(41, value);
  }

  Map<String, dynamic> get StringMap {
    return get(42);
  }

  set StringMap(Map<String, dynamic> value) {
    set(42, value);
  }

  Map<int, String> get IntStringMap {
    return get(43);
  }

  set IntStringMap(Map<int, String> value) {
    set(43, value);
  }

  dynamic get Object {
    return get(44);
  }

  set Object(dynamic value) {
    set(44, value);
  }

  List get ObjectArray {
    return get(45);
  }

  set ObjectArray(List value) {
    set(45, value);
  }

  List<test.MyResource> get MyResources {
    return get(46);
  }

  set MyResources(List<test.MyResource> value) {
    set(46, value);
  }

  final _StringEventController = StreamController<String>();
  Stream<String> get StringEvent {
    return _StringEventController.stream;
  }

  final _ArrayEventController = StreamController<List>();
  Stream<List> get ArrayEvent {
    return _ArrayEventController.stream;
  }

  TemplateDescriber get template => TemplateDescriber('Test.MyService',
      properties: [
        Prop('PropertyContext', getTypeOf<int>(),
            r'DistributedPropertyContext`1', null),
        Prop('Enum', getTypeOf<test.SizeEnum>(), r'SizeEnum', null),
        Prop('Record', getTypeOf<test.MyRecord>(), r'MyRecord', null),
        Prop('IntList', getTypeOf<List<int>>(), r'List`1', null),
        Prop('RecordsArray', getTypeOf<List<IRecord>>(), r'IRecord[]', null),
        Prop('RecordsList', getTypeOf<List<test.MyRecord>>(), r'List`1', null),
        Prop('Resource', getTypeOf<test.MyResource>(), r'MyResource', null),
        Prop('ChildResource', getTypeOf<test.MyChildResource>(),
            r'MyChildResource', null),
        Prop('ChildRecord', getTypeOf<test.MyChildRecord>(), r'MyChildRecord',
            null),
        Prop('Resources', getTypeOf<List<IResource>>(), r'IResource[]', null),
        Prop('Me', getTypeOf<MyService>(), r'MyService', null),
        Prop('Boolean', getTypeOf<bool>(), r'Boolean', null),
        Prop('BooleanArray', getTypeOf<List<bool>>(), r'Boolean[]', null),
        Prop('UInt8Test', getTypeOf<int>(), r'Byte', null),
        Prop('UInt8Null', getTypeOf<int?>(), r'Nullable`1?', null),
        Prop('UInt8Array', getTypeOf<List<int>>(), r'Byte[]', null),
        Prop('UInt8ArrayNull', getTypeOf<List<int?>>(), r'Nullable`1[]', null),
        Prop('Int8', getTypeOf<int>(), r'SByte', null),
        Prop('Int8Array', getTypeOf<List<int>>(), r'SByte[]', null),
        Prop('Char16', getTypeOf<String>(), r'Char', null),
        Prop('Char16Array', getTypeOf<List<String>>(), r'Char[]', null),
        Prop('Int16', getTypeOf<int>(), r'Int16', null),
        Prop('Int16Array', getTypeOf<List<int>>(), r'Int16[]', null),
        Prop('UInt16', getTypeOf<int>(), r'UInt16', null),
        Prop('UInt16Array', getTypeOf<List<int>>(), r'UInt16[]', null),
        Prop('Int32Prop', getTypeOf<int>(), r'Int32', null),
        Prop('Int32Array', getTypeOf<List<int>>(), r'Int32[]', null),
        Prop('UInt32', getTypeOf<int>(), r'UInt32', null),
        Prop('UInt32Array', getTypeOf<List<int>>(), r'UInt32[]', null),
        Prop('Int64', getTypeOf<int>(), r'Int64', null),
        Prop('Int64Array', getTypeOf<List<int>>(), r'Int64[]', null),
        Prop('UInt64', getTypeOf<int>(), r'UInt64', null),
        Prop('UInt64Array', getTypeOf<List<int>>(), r'UInt64[]', null),
        Prop('Float32', getTypeOf<double>(), r'Single', null),
        Prop('Float32Array', getTypeOf<List<double>>(), r'Single[]', null),
        Prop('Float64', getTypeOf<double>(), r'Double', null),
        Prop('Float64Array', getTypeOf<List<double>>(), r'Double[]', null),
        Prop('Float128', getTypeOf<double>(), r'Decimal', null),
        Prop('Float128Array', getTypeOf<List<double>>(), r'Decimal[]', null),
        Prop('Text', getTypeOf<String>(), r'String', null),
        Prop('StringArray', getTypeOf<List<String>>(), r'String[]', null),
        Prop('Time', getTypeOf<DateTime>(), r'DateTime', null),
        Prop('StringMap', getTypeOf<Map<String, dynamic>>(), r'Map`2', null),
        Prop('IntStringMap', getTypeOf<Map<int, String>>(), r'Map`2', null),
        Prop('Object', getTypeOf<dynamic>(), r'Object', null),
        Prop('ObjectArray', getTypeOf<List>(), r'Object[]', null),
        Prop('MyResources', getTypeOf<List<test.MyResource>>(), r'MyResource[]',
            null)
      ],
      functions: [
        Func(
            'GetGenericRecord',
            getTypeOf<test.MyGenericRecordOfTest_MyResource>(),
            [],
            r'() -> MyGenericRecord`1'),
        Func('Void', getTypeOf<dynamic>(), [], r'() -> Void'),
        Func(
            'InvokeEvents',
            getTypeOf<dynamic>(),
            [Arg('msg', getTypeOf<String>(), false)],
            r'([String] msg) -> Void'),
        Func(
            'Optional',
            getTypeOf<double>(),
            [
              Arg('a1', getTypeOf<dynamic>(), false),
              Arg('a2', getTypeOf<int>(), false),
              Arg('a3', getTypeOf<String>(), true),
              Arg('a4', getTypeOf<String>(), true)
            ],
            r'([Object] a1,[Int32] a2,[String] a3,[String] a4) -> Double'),
        Func(
            'Connection',
            getTypeOf<dynamic>(),
            [
              Arg('a1', getTypeOf<dynamic>(), false),
              Arg('a2', getTypeOf<int>(), false)
            ],
            r'([Object] a1,[Int32] a2) -> Void'),
        Func(
            'ConnectionOptional',
            getTypeOf<dynamic>(),
            [
              Arg('a1', getTypeOf<dynamic>(), false),
              Arg('a2', getTypeOf<int>(), false),
              Arg('a3', getTypeOf<String>(), true)
            ],
            r'([Object] a1,[Int32] a2,[String] a3) -> Void'),
        Func(
            'GetTuple2',
            getTypeOf<Tuple>(),
            [
              Arg('a1', getTypeOf<int>(), false),
              Arg('a2', getTypeOf<String>(), false)
            ],
            r'([Int32] a1,[String] a2) -> ValueTuple`2'),
        Func(
            'GetTuple3',
            getTypeOf<Tuple>(),
            [
              Arg('a1', getTypeOf<int>(), false),
              Arg('a2', getTypeOf<String>(), false),
              Arg('a3', getTypeOf<double>(), false)
            ],
            r'([Int32] a1,[String] a2,[Double] a3) -> ValueTuple`3'),
        Func(
            'GetTuple4',
            getTypeOf<Tuple>(),
            [
              Arg('a1', getTypeOf<int>(), false),
              Arg('a2', getTypeOf<String>(), false),
              Arg('a3', getTypeOf<double>(), false),
              Arg('a4', getTypeOf<bool>(), false)
            ],
            r'([Int32] a1,[String] a2,[Double] a3,[Boolean] a4) -> ValueTuple`4'),
        Func(
            'SendRecord',
            getTypeOf<test.MyRecord>(),
            [Arg('record', getTypeOf<test.MyRecord>(), false)],
            r'([MyRecord] record) -> MyRecord')
      ],
      events: [
        Evt('StringEvent', getTypeOf<String>(), false, null),
        Evt('ArrayEvent', getTypeOf<List>(), false, null)
      ],
      annotation: null);
}
